/* -----------------------------------------------------------------------------
 *    ___   __    __       _      __              __   __
 *   / _ | / /__ / /____ _| | /| / /__  ___  ____/ /  / /____ ____
 *  / __ |/  '_//  '_/ // / |/ |/ / _ `/ -_)/ __/ _ \/ __/ -_) __/
 * /_/ |_/_/\_\/_/\_\\_,_/|__/|__/\_,_/\__/ \__/_//_/\__/\__/_/
 *
 * 080824-1 (c)2009 Elektor International Media B.V.
 * -------------------------------------------------------------------------- */
/* -----------------------------------------------------------------------------
 * This file contains the definition used in this firmware for the NXP LPC2103.
 * This file is not generic but might be complete to achieve this status.
 * Contributions are very welcome.
 * -------------------------------------------------------------------------- */

#ifndef __LPC2103_H__
#define __LPC2103_H__

/* ----------------------------------------------------------------------------
 * APB (ARM Peripheral Bus) Divider
 * ------------------------------------------------------------------------- */
#define APBDIV         (*((volatile unsigned char *) 0xE01FC100))

/* ----------------------------------------------------------------------------
 * VIC: Vectored Interrupt Controller
 * ------------------------------------------------------------------------- */
#define VICIntEnable   (*((volatile unsigned long *) 0xFFFFF010))
#define VICVectAddr    (*((volatile unsigned long *) 0xFFFFF030))
#define VICVectAddr1   (*((volatile unsigned long *) 0xFFFFF104))
#define VICVectCntl1   (*((volatile unsigned long *) 0xFFFFF204))

/* ----------------------------------------------------------------------------
 * Pin to Function Connection Block
 * ------------------------------------------------------------------------- */
#define PINSEL0        (*((volatile unsigned long *) 0xE002C000))
#define PINSEL1        (*((volatile unsigned long *) 0xE002C004))

/* ----------------------------------------------------------------------------
 * GPIO: General Purpose Input/Output
 * ------------------------------------------------------------------------- */
#define IOPIN          (*((volatile unsigned long *) 0xE0028000))
#define IOSET          (*((volatile unsigned long *) 0xE0028004))
#define IODIR          (*((volatile unsigned long *) 0xE0028008))
#define IOCLR          (*((volatile unsigned long *) 0xE002800C))

/* ----------------------------------------------------------------------------
 * UART0: Universal Asynchronous Receiver Transmitter 0
 * ------------------------------------------------------------------------- */
#define U0THR          (*((volatile unsigned char *) 0xE000C000))
#define U0FCR          (*((volatile unsigned char *) 0xE000C008))
#define U0LCR          (*((volatile unsigned char *) 0xE000C00C))
#define U0LSR          (*((volatile unsigned char *) 0xE000C014))
#define U0DLL          (*((volatile unsigned char *) 0xE000C000))
#define U0DLM          (*((volatile unsigned char *) 0xE000C004))

/* ----------------------------------------------------------------------------
 * SPI0: Serial Peripheral Interface 0
 * ------------------------------------------------------------------------- */
#define S0SPCR         (*((volatile unsigned short*) 0xE0020000))
#define S0SPSR         (*((volatile unsigned char *) 0xE0020004))
#define S0SPDR         (*((volatile unsigned short*) 0xE0020008))
#define S0SPCCR        (*((volatile unsigned char *) 0xE002000C))

/* ----------------------------------------------------------------------------
 * ADC0: 10bits Analog to Digital Converter
 * ------------------------------------------------------------------------- */
#define AD0CR          (*((volatile unsigned long *) 0xE0034000))
#define AD0GDR         (*((volatile unsigned long *) 0xE0034004))

/* ----------------------------------------------------------------------------
 * Timer 0
 * ------------------------------------------------------------------------- */
#define T0IR           (*((volatile unsigned char *) 0xE0004000))
#define T0TCR          (*((volatile unsigned char *) 0xE0004004))
#define T0TC           (*((volatile unsigned long *) 0xE0004008))
#define T0PR           (*((volatile unsigned long *) 0xE000400C))
#define T0MCR          (*((volatile unsigned short*) 0xE0004014))
#define T0MR0          (*((volatile unsigned long *) 0xE0004018))

/* ----------------------------------------------------------------------------
 * Timer 1
 * ------------------------------------------------------------------------- */
#define T1TCR          (*((volatile unsigned char *) 0xE0008004))
#define T1TC           (*((volatile unsigned long *) 0xE0008008))
#define T1PR           (*((volatile unsigned long *) 0xE000800C))

/* ----------------------------------------------------------------------------
 * Timer 2
 * ------------------------------------------------------------------------- */
#define T2TCR          (*((volatile unsigned char *) 0xE0070004))
#define T2TC           (*((volatile unsigned short*) 0xE0070008))
#define T2PR           (*((volatile unsigned short*) 0xE007000C))
#define T2MCR          (*((volatile unsigned short*) 0xE0070014))
#define T2MR2          (*((volatile unsigned short*) 0xE0070020))
#define T2MR3          (*((volatile unsigned short*) 0xE0070024))
#define T2EMR          (*((volatile unsigned short*) 0xE007003C))
#define T2PWMCON       (*((volatile unsigned long *) 0xE0070074))


#endif  // __LPC2103_H__
